﻿using System;
using System.Linq;
using DAL;
using Domain;
using EFLogging;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.DependencyInjection;

namespace ConsoleApp
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Hello EF!");
            using (var ctx = new AppDbContext())
            {
                ctx.GetInfrastructure()
                    .GetService<ILoggerFactory>()
                    .AddProvider(new CustomLoggerProvider());
            }

            using (var ctx = new AppDbContext())
            {
                var np = new Person()
                {
                    FirstName = "Andres",
                    LastName = "Käver"
                };
                Console.WriteLine(np.PersonId);
                ctx.Persons.Add(np);
                Console.WriteLine(np.PersonId);
                ctx.SaveChanges();
                Console.WriteLine(np.PersonId);
             }
            using (var ctx = new AppDbContext())
            {
                foreach (var person in ctx.Persons.OrderBy(p => p.FirstName).Take(1))
                {
                    Console.WriteLine(person.FirstLastName);
                }
            }
        }
    }
}