﻿using System;
using System.IO;
using Microsoft.Extensions.Logging;

namespace EFLogging
{
    public class CustomLoggerProvider : ILoggerProvider
    {
 
        public ILogger CreateLogger(string categoryName)
        {
            return new CustomLogger();
        }
        public void Dispose()
        {
        }

        private class CustomLogger : ILogger
        {
            public void Log<TState>(
                LogLevel logLevel, EventId eventId, TState state, Exception exception, 
                Func<TState, Exception, string> formatter)
            {
               // Console.WriteLine(logLevel);
                if (logLevel == LogLevel.Information)
                {
                    Console.WriteLine(formatter(state, exception));
                    File.AppendAllText(@"c:\!\eflog.txt", formatter(state, exception));
                }
            }

            public bool IsEnabled(LogLevel logLevel)
            {
                return true;
            }

            public IDisposable BeginScope<TState>(TState state)
            {
                return null;
            }
        }
    }
}
